## erlang 27.3.4.4+dfsg

=== erts/doc/Makefile ===
#
# %CopyrightBegin%
#
# Copyright Ericsson AB 2004-2024. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# %CopyrightEnd%
#
include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

# ----------------------------------------------------
# Application version
# ----------------------------------------------------
include ../vsn.mk
APPLICATION = erts
INDEX_DIR = ../../../doc
RELSYSDIR = $(RELEASE_PATH)/$(APPLICATION)-$(VSN)
EPUB=false

assets:
	$(V_at)mkdir assets
assets/%: ../emulator/internal_doc/assets/% | assets
	$(V_at)cp $< $@
assets/gen_tcp_dist.erl: ../../lib/kernel/examples/gen_tcp_dist/src/gen_tcp_dist.erl | assets
	$(V_at)cp $< $@
assets/erl_uds_dist.erl: ../../lib/kernel/examples/erl_uds_dist/src/erl_uds_dist.erl | assets
	$(V_at)cp $< $@
assets/time_compat.erl: ../example/time_compat.erl
	$(V_at)cp $< $@

$(HTMLDIR)/index.html: $(patsubst ../emulator/internal_doc/assets/%,assets/%,$(wildcard ../emulator/internal_doc/assets/*.png) $(wildcard ../emulator/internal_doc/assets/*.svg)) assets/gen_tcp_dist.erl assets/erl_uds_dist.erl assets/time_compat.erl

# ----------------------------------------------------
# Release Target
# ----------------------------------------------------
include $(ERL_TOP)/make/doc.mk

=== erts/epmd/Makefile ===
# 
# %CopyrightBegin%
# 
# Copyright Ericsson AB 1998-2021. All Rights Reserved.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# %CopyrightEnd%
# 
include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

# ----------------------------------------------------
# Common Macros
# ----------------------------------------------------
SUB_DIRECTORIES = src 

SPECIAL_TARGETS = 

# ----------------------------------------------------
# Default Subdir Targets
# ----------------------------------------------------
include $(ERL_TOP)/make/otp_subdir.mk

include $(ERL_TOP)/make/app_targets.mk

=== erts/etc/Makefile ===
#
# %CopyrightBegin%
# 
# Copyright Ericsson AB 1999-2022. All Rights Reserved.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# %CopyrightEnd%
#
include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

SUB_DIRECTORIES = common
ifeq ($(TARGET),win32)
SUB_DIRECTORIES += win32
else
SUB_DIRECTORIES += unix
endif

include $(ERL_TOP)/make/otp_subdir.mk

=== erts/preloaded/Makefile ===
# 
# %CopyrightBegin%
# 
# Copyright Ericsson AB 2008-2016. All Rights Reserved.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# %CopyrightEnd%
# 
include $(ERL_TOP)/make/target.mk

SUB_DIRECTORIES = src

include $(ERL_TOP)/make/otp_subdir.mk

=== erts/start_scripts/Makefile ===
#
# %CopyrightBegin%
#
# Copyright Ericsson AB 1997-2017. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# %CopyrightEnd%
#

.NOTPARALLEL:

include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

# ----------------------------------------------------
# Release directory specification
# ----------------------------------------------------

SS_ROOT = $(ERL_TOP)/erts/start_scripts
SS_TMP = $(SS_ROOT)/tmp
LIBPATH= $(ERL_TOP)/lib
SCRIPT_PATH = -I$(LIBPATH)/kernel/ebin -I$(LIBPATH)/stdlib/ebin -I$(LIBPATH)/sasl/ebin
BOOTSTRAP_LIBPATH=$(BOOTSTRAP_TOP)/lib
BOOTSTRAP_SCRIPT_PATH = -I$(BOOTSTRAP_LIBPATH)/kernel/ebin -I$(BOOTSTRAP_LIBPATH)/stdlib/ebin

INSTALL_SCRIPTS = \
	$(SS_ROOT)/start_clean.script \
	$(SS_ROOT)/start_clean.boot \
	$(SS_ROOT)/start_sasl.boot \
	$(SS_ROOT)/start_sasl.script \
	$(SS_ROOT)/no_dot_erlang.boot \
	$(SS_ROOT)/no_dot_erlang.script


REL_SCRIPTS = \
	$(SS_ROOT)/start_clean.rel \
	$(SS_ROOT)/start_sasl.rel \
	$(SS_ROOT)/start_all_example.rel \
	$(SS_ROOT)/no_dot_erlang.rel \

ifneq ($(findstring win32,$(TARGET)),win32)
RELEASES_SRC = RELEASES.src
endif

##############################################################################
# Get version numbers from the VSN files

# VSN
include ../vsn.mk
include $(LIBPATH)/kernel/vsn.mk
include $(LIBPATH)/stdlib/vsn.mk
-include $(LIBPATH)/sasl/vsn.mk
-include $(LIBPATH)/os_mon/vsn.mk
-include $(LIBPATH)/mnesia/vsn.mk
-include $(LIBPATH)/snmp/vsn.mk
-include $(LIBPATH)/inets/vsn.mk

##############################################################################

debug opt lcnt script: rel $(INSTALL_SCRIPTS) $(RELEASES_SRC)

rel:	$(REL_SCRIPTS)

RELEASES.src: $(SS_ROOT)/start_sasl.rel
	$(gen_verbose)$(INSTALL_DIR) $(SS_TMP)
	$(V_at)( cd $(SS_TMP) && \
	$(ERL) -noinput +B -eval 'release_handler:create_RELEASES("%ERL_ROOT%", "$(SS_ROOT)", "$(SS_ROOT)/start_sasl.rel", []), halt()')
	$(V_at)mv RELEASES RELEASES.src

$(SS_ROOT)/start_clean.script \
$(SS_ROOT)/start_clean.boot:	$(SS_ROOT)/start_clean.rel
	$(gen_verbose)$(INSTALL_DIR) $(SS_TMP)
	$(V_at)( cd $(SS_TMP) && \
	$(ERLC) $(SASL_FLAGS) $(SCRIPT_PATH) +no_warn_sasl -o $(SS_ROOT) $< )

$(SS_ROOT)/start_sasl.script \
$(SS_ROOT)/start_sasl.boot:	$(SS_ROOT)/start_sasl.rel
	$(gen_verbose)$(INSTALL_DIR) $(SS_TMP)
	$(V_at)( cd $(SS_TMP) && \
	$(ERLC) $(SASL_FLAGS) $(SCRIPT_PATH) -o $(SS_ROOT) $< )

$(SS_ROOT)/no_dot_erlang.script \
$(SS_ROOT)/no_dot_erlang.boot:	$(SS_ROOT)/no_dot_erlang.rel
	$(gen_verbose)$(INSTALL_DIR) $(SS_TMP)
	$(V_at)( cd $(SS_TMP) && \
	$(ERLC) $(SASL_FLAGS) $(SCRIPT_PATH) +no_warn_sasl +no_dot_erlang -o $(SS_ROOT) $< )


$(SS_ROOT)/start_clean.rel: $(SS_ROOT)/start_clean.rel.src \
			../vsn.mk \
			$(LIBPATH)/kernel/vsn.mk \
			$(LIBPATH)/stdlib/vsn.mk
	$(gen_verbose)sed -e 's;%SYS_VSN%;$(SYSTEM_VSN);' \
            -e 's;%ERTS_VSN%;$(VSN);' \
            -e 's;%KERNEL_VSN%;$(KERNEL_VSN);' \
            -e 's;%STDLIB_VSN%;$(STDLIB_VSN);' \
          $(SS_ROOT)/start_clean.rel.src > $(SS_ROOT)/start_clean.rel

$(SS_ROOT)/start_sasl.rel:	$(SS_ROOT)/start_sasl.rel.src \
			../vsn.mk \
			$(LIBPATH)/kernel/vsn.mk \
			$(LIBPATH)/stdlib/vsn.mk \
			$(LIBPATH)/sasl/vsn.mk
	$(gen_verbose)sed -e 's;%SYS_VSN%;$(SYSTEM_VSN);' \
            -e 's;%ERTS_VSN%;$(VSN);' \
            -e 's;%KERNEL_VSN%;$(KERNEL_VSN);' \
            -e 's;%STDLIB_VSN%;$(STDLIB_VSN);' \
            -e 's;%SASL_VSN%;$(SASL_VSN);' \
          $(SS_ROOT)/start_sasl.rel.src > $(SS_ROOT)/start_sasl.rel

$(SS_ROOT)/no_dot_erlang.rel: $(SS_ROOT)/no_dot_erlang.rel.src \
			../vsn.mk \
			$(LIBPATH)/kernel/vsn.mk \
			$(LIBPATH)/stdlib/vsn.mk
	$(gen_verbose)sed -e 's;%SYS_VSN%;$(SYSTEM_VSN);' \
            -e 's;%ERTS_VSN%;$(VSN);' \
            -e 's;%KERNEL_VSN%;$(KERNEL_VSN);' \
            -e 's;%STDLIB_VSN%;$(STDLIB_VSN);' \
          $(SS_ROOT)/no_dot_erlang.rel.src > $(SS_ROOT)/no_dot_erlang.rel

$(SS_ROOT)/start_all_example.rel:	$(SS_ROOT)/start_all_example.rel.src \
			../vsn.mk \
			$(LIBPATH)/kernel/vsn.mk \
			$(LIBPATH)/stdlib/vsn.mk \
			$(LIBPATH)/sasl/vsn.mk \
			$(LIBPATH)/os_mon/vsn.mk \
			$(LIBPATH)/mnesia/vsn.mk \
			$(LIBPATH)/snmp/vsn.mk \
			$(LIBPATH)/inets/vsn.mk
	$(gen_verbose)sed -e 's;%SYS_VSN%;$(SYSTEM_VSN);' \
            -e 's;%ERTS_VSN%;$(VSN);' \
            -e 's;%KERNEL_VSN%;$(KERNEL_VSN);' \
            -e 's;%STDLIB_VSN%;$(STDLIB_VSN);' \
            -e 's;%SASL_VSN%;$(SASL_VSN);' \
            -e 's;%OS_MON_VSN%;$(OS_MON_VSN);' \
            -e 's;%MNESIA_VSN%;$(MNESIA_VSN);' \
            -e 's;%SNMP_VSN%;$(SNMPEA_VSN);' \
            -e 's;%INETS_VSN%;$(INETS_VSN);' \
          $(SS_ROOT)/start_all_example.rel.src > $(SS_ROOT)/start_all_example.rel

## Special target used from $(ERL_TOP)/erts/Makefile.
$(ERL_TOP)/bin/start.script:
	$(gen_verbose)$(INSTALL_DIR) $(SS_TMP)
	$(V_at)( cd $(SS_TMP) && \
	  $(ERLC) $(SCRIPT_PATH) +no_warn_sasl +otp_build -o $@ $(SS_ROOT)/start_clean.rel )

$(ERL_TOP)/bin/start_sasl.script:
	$(gen_verbose)$(INSTALL_DIR) $(SS_TMP)
	$(V_at)( cd $(SS_TMP) && \
	  $(ERLC) $(SCRIPT_PATH) +otp_build -o $@ $(SS_ROOT)/start_sasl.rel )

$(ERL_TOP)/bin/start_clean.script:
	$(gen_verbose)$(INSTALL_DIR) $(SS_TMP)
	$(V_at)( cd $(SS_TMP) && \
	  $(ERLC) $(SCRIPT_PATH) +no_warn_sasl +otp_build -o $@ $(SS_ROOT)/start_clean.rel )

$(ERL_TOP)/bin/no_dot_erlang.script:
	$(gen_verbose)$(INSTALL_DIR) $(SS_TMP)
	$(V_at)( cd $(SS_TMP) && \
	  $(ERLC) $(SCRIPT_PATH) +no_warn_sasl +otp_build +no_dot_erlang -o $@ $(SS_ROOT)/no_dot_erlang.rel )

## Special target used from system/build/Makefile for source code release bootstrap.
bootstrap_scripts: $(SS_ROOT)/start_clean.rel $(SS_ROOT)/no_dot_erlang.rel
	$(V_at)$(INSTALL_DIR) $(TESTROOT)/bin
	$(V_at)$(INSTALL_DIR) $(SS_TMP)
	$(V_at)( cd $(SS_TMP) && \
	  $(ERLC) $(BOOTSTRAP_SCRIPT_PATH) +otp_build +no_module_tests \
	    -o $(TESTROOT)/bin/start.script $(SS_ROOT)/start_clean.rel )
	$(V_at)( cd $(SS_TMP) && \
	  $(ERLC) $(BOOTSTRAP_SCRIPT_PATH) +otp_build +no_module_tests \
	    -o $(TESTROOT)/bin/start_clean.script $(SS_ROOT)/start_clean.rel )
	$(V_at)( cd $(SS_TMP) && \
	  $(ERLC) $(BOOTSTRAP_SCRIPT_PATH) +otp_build +no_module_tests \
	    -o $(TESTROOT)/bin/no_dot_erlang.script $(SS_ROOT)/no_dot_erlang.rel )


clean:
	$(V_at)$(RM) $(REL_SCRIPTS) $(INSTALL_SCRIPTS)

docs:


# ----------------------------------------------------
# Release Target
# ---------------------------------------------------- 
include $(ERL_TOP)/make/otp_release_targets.mk

release_spec: script
	$(V_at)$(INSTALL_DIR) "$(RELEASE_PATH)/releases/$(SYSTEM_VSN)"
ifneq ($(findstring win32,$(TARGET)),win32)
	$(V_at)$(INSTALL_DATA) RELEASES.src "$(RELEASE_PATH)/releases"
endif
	$(V_at)$(INSTALL_DATA) $(INSTALL_SCRIPTS) $(REL_SCRIPTS) \
	   "$(RELEASE_PATH)/releases/$(SYSTEM_VSN)"
	$(V_at)$(INSTALL_DATA) start_clean.script "$(RELEASE_PATH)/releases/$(SYSTEM_VSN)/start.script"
	$(V_at)$(INSTALL_DATA) start_clean.boot "$(RELEASE_PATH)/releases/$(SYSTEM_VSN)/start.boot"


release_docs_spec:

TRUE:

=== erts/test/Makefile ===
#
# %CopyrightBegin%
#
# Copyright Ericsson AB 1997-2024. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# %CopyrightEnd%
#

include $(ERL_TOP)/make/target.mk

include $(ERL_TOP)/make/$(TARGET)/otp.mk

EBIN = .

# ----------------------------------------------------
# Target Specs
# ----------------------------------------------------

MODULES= \
	erlc_SUITE \
	install_SUITE \
	nt_SUITE \
	otp_SUITE \
	ethread_SUITE \
	erl_print_SUITE \
	run_erl_SUITE \
	erlexec_SUITE \
	z_SUITE \
	upgrade_SUITE \
	parallel_messages_SUITE

ERTS_MODULES= erts_test_utils

ERL_FILES= $(MODULES:%=%.erl) \
           $(ERTS_MODULES:%=$(ERL_TOP)/erts/emulator/test/%.erl)

TARGET_FILES = $(MODULES:%=$(EBIN)/%.$(EMULATOR))

EXTRA_FILES = install_SUITE_data/install_bin

# ----------------------------------------------------
# Release directory specification
# ----------------------------------------------------
RELSYSDIR = $(RELEASE_PATH)/system_test

# ----------------------------------------------------
# FLAGS
# ----------------------------------------------------
ERL_COMPILE_FLAGS += +nowarn_missing_spec_documented

# ----------------------------------------------------
# Targets
# ----------------------------------------------------

tests debug opt: $(TARGET_FILES) $(EXTRA_FILES)

install_SUITE_data/install_bin: ../../make/install_bin
	rm -f $@
	cp -p $< $@

clean:
	rm -f $(TARGET_FILES) $(EXTRA_FILES)
	rm -f core *~

docs:

# ----------------------------------------------------
# Release Target
# ---------------------------------------------------- 
include $(ERL_TOP)/make/otp_release_targets.mk

release_spec:

release_tests_spec: opt
	$(INSTALL_DIR) "$(RELSYSDIR)"
	$(INSTALL_DATA) system.spec system.dynspec system_smoke.spec \
		$(ERL_FILES) $(TARGET_FILES) "$(RELSYSDIR)"
	chmod -R u+w "$(RELSYSDIR)"
	cp "$(ERL_TOP)/otp_versions.table" "$(ERL_TOP)/erts/test/otp_SUITE_data"
	cp "$(ERL_TOP)/make/otp_version_tickets" "$(ERL_TOP)/erts/test/otp_SUITE_data"
	tar cf - *_SUITE_data utils | (cd "$(RELSYSDIR)"; tar xf -)

release_docs_spec:

=== lib/asn1/Makefile ===
#
# %CopyrightBegin%
# 
# Copyright Ericsson AB 1997-2024. All Rights Reserved.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# %CopyrightEnd%
#
#
include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

#
# Macros
#

SUB_DIRECTORIES = src doc c_src

static_lib: SUB_DIRECTORIES = c_src


include vsn.mk
VSN = $(ASN1_VSN)

DIR_NAME = asn1-$(VSN)

ifndef APP_RELEASE_DIR
  APP_RELEASE_DIR = /tmp
endif

ifndef APP_TAR_FILE
  APP_TAR_FILE = $(APP_RELEASE_DIR)/$(DIR_NAME).tgz
endif

APP_DIR = $(APP_RELEASE_DIR)/$(DIR_NAME)


SPECIAL_TARGETS = 

#
# Default Subdir Targets
#
include $(ERL_TOP)/make/otp_subdir.mk


.PHONY: version

version:
	@echo "$(VSN)"

include $(ERL_TOP)/make/app_targets.mk

=== lib/debugger/Makefile ===
#
# %CopyrightBegin%
# 
# Copyright Ericsson AB 1997-2024. All Rights Reserved.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# %CopyrightEnd%
#

#
include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

# ----------------------------------------------------
# Common Macros
# ----------------------------------------------------

SUB_DIRECTORIES = src priv doc

SPECIAL_TARGETS = 

# ----------------------------------------------------
# Default Subdir Targets
# ----------------------------------------------------
include $(ERL_TOP)/make/otp_subdir.mk

DIA_PLT_APPS=wx

include $(ERL_TOP)/make/app_targets.mk

=== lib/et/Makefile ===
#
# %CopyrightBegin%
# 
# Copyright Ericsson AB 2002-2021. All Rights Reserved.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# %CopyrightEnd%
#

#
include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

# ----------------------------------------------------
# Common Macros
# ----------------------------------------------------

include subdirs.mk

SPECIAL_TARGETS = 

# ----------------------------------------------------
# Default Subdir Targets
# ----------------------------------------------------
include $(ERL_TOP)/make/otp_subdir.mk

DIA_PLT_APPS=runtime_tools wx

include $(ERL_TOP)/make/app_targets.mk

=== lib/kernel/Makefile ===
#
# %CopyrightBegin%
# 
# Copyright Ericsson AB 1996-2023. All Rights Reserved.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# %CopyrightEnd%
#
include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

# ----------------------------------------------------
# Common Macros
# ----------------------------------------------------
include vsn.mk
VSN = $(KERNEL_VSN)

SUB_DIRECTORIES = src doc examples

SPECIAL_TARGETS = 

# ----------------------------------------------------
# Default Subdir Targets
# ----------------------------------------------------
include $(ERL_TOP)/make/otp_subdir.mk

DIA_PLT_APPS=crypto compiler
TEST_NEEDS_RELEASE=true

include $(ERL_TOP)/make/app_targets.mk

=== lib/mnesia/Makefile ===
#
# %CopyrightBegin%
# 
# Copyright Ericsson AB 1996-2024. All Rights Reserved.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# %CopyrightEnd%
#

#
include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

# ----------------------------------------------------
# Macros
# ----------------------------------------------------

SUB_DIRECTORIES = src include examples doc

include vsn.mk
VSN = $(MNESIA_VSN)

SPECIAL_TARGETS = 

# ----------------------------------------------------
# Default Subdir Targets
# ----------------------------------------------------
include $(ERL_TOP)/make/otp_subdir.mk

include $(ERL_TOP)/make/app_targets.mk

=== lib/observer/Makefile ===
#
# %CopyrightBegin%
# 
# Copyright Ericsson AB 2002-2024. All Rights Reserved.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# %CopyrightEnd%
#
include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

#
# Macros
#

SUB_DIRECTORIES = src doc

include vsn.mk
VSN = $(OBSERVER_VSN)

SPECIAL_TARGETS = 

#
# Default Subdir Targets
#
include $(ERL_TOP)/make/otp_subdir.mk

DIA_PLT_APPS=runtime_tools et wx

include $(ERL_TOP)/make/app_targets.mk

=== debian/control ===
Source: erlang
Maintainer: Debian Erlang Packagers <pkg-erlang-devel@lists.alioth.debian.org>
Uploaders: Sergei Golovan <sgolovan@debian.org>
Section: interpreters
Priority: optional
Standards-Version: 4.7.0
Build-Depends: debhelper-compat (= 13), autoconf (>= 2.72), openssl, libssl-dev, m4,
 libncurses-dev, unixodbc-dev, bison, flex, ed, zlib1g-dev,
 libwxgtk3.2-dev, libwxgtk-webview3.2-dev, libx11-dev, dctrl-tools,
 libgl-dev, libglu-dev, ronn,
 libsctp-dev [linux-any], libsystemd-dev [linux-any], erlang-base:native <cross>
Build-Depends-Indep: elixir-ex-doc (>= 0.35.1+dfsg-4~) <!nodoc>, default-jdk | sun-java6-jdk
Build-Conflicts: autoconf2.13, libwxgtk2.4-dev, libwxgtk2.6-dev, libwxgtk2.8-dev, libwxgtk3.0-dev, libwxgtk3.0-gtk3-dev
Homepage: http://www.erlang.org/
Vcs-Browser: https://salsa.debian.org/erlang-team/packages/erlang
Vcs-Git: https://salsa.debian.org/erlang-team/packages/erlang.git

Package: erlang-base
Architecture: any
Multi-Arch: allowed
Depends: procps, adduser, ${shlibs:Depends}, ${misc:Depends}
Recommends: ${libsctp:Version}, erlang-crypto (= ${binary:Version})
Suggests: erlang-tools (= ${binary:Version}),  erlang, erlang-doc
Conflicts: erlang (<< ${source:Version}), erlang-base-hipe, erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2), erlang-doc-html (<< 1:13.b.4)
Replaces: erlang (<< ${source:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${source:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-typer (<< 1:20.0+dfsg), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2), erlang-doc-html (<< 1:13.b.4)
Provides: erlang-abi (= 17.0), erlang-pcre (= 8.44), erlang-abi-17.0
Breaks: rabbitmq-server (<< 3.7.7)
Description: Erlang/OTP virtual machine and base applications
 This package contains the Erlang/OTP runtime implementation,
 and minimal set of Erlang applications:
  compiler - compiles Erlang code to byte-code;
  erts - the Erlang runtime system application;
  kernel - code necessary to run the Erlang runtime system itself;
  ose - code for Enea OSE operating system;
  sasl - the system architecture support libraries application;
  stdlib - modules for manipulating lists, strings, files etc.


Package: erlang-asn1
Architecture: any
Multi-Arch: allowed
Depends: erlang-base (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: erlang, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP modules for ASN.1 support
 The Asn1 application contains modules with compile-time and run-time
 support for ASN.1 in Erlang/OTP.


Package: erlang-common-test
Architecture: any
Multi-Arch: allowed
Depends: erlang-base (= ${binary:Version}), erlang-crypto (= ${binary:Version}), erlang-debugger (= ${binary:Version}), erlang-ftp (= ${binary:Version}), erlang-runtime-tools (= ${binary:Version}), erlang-snmp (= ${binary:Version}), erlang-ssh (= ${binary:Version}), erlang-syntax-tools (= ${binary:Version}), erlang-tools (= ${binary:Version}), erlang-xmerl (= ${binary:Version}), libjs-jquery, libjs-jquery-tablesorter, ${shlibs:Depends}, ${misc:Depends}
Suggests: erlang, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP application for automated testing
 Common Test is a portable application for automated testing. It is
 suitable for black-box testing of target systems of any type (i.e.
 not necessarily implemented in Erlang), as well as for white-box
 testing of Erlang/OTP programs. Black-box testing is performed via
 standard interfaces (such as SNMP, HTTP, Corba, Telnet, etc) and,
 if required, via user specific interfaces (often called test ports).
 White-box testing of Erlang/OTP programs is easily accomplished by
 calling the target API functions directly from the test case functions.
 Common Test also integrates usage of the OTP cover tool for code
 coverage analysis of Erlang/OTP programs.


Package: erlang-crypto
Architecture: any
Multi-Arch: allowed
Depends: erlang-base (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: erlang, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP cryptographic modules
 The Crypto Application provides functions for computation of message
 digests, encryption and decryption functions. It uses OpenSSL for
 actual calculations.


Package: erlang-debugger
Architecture: any
Multi-Arch: allowed
Depends: erlang-base (= ${binary:Version}), erlang-wx (= ${binary:Version}), ${misc:Depends}
Suggests: erlang, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP application for debugging and testing
 Debugger is a graphical tool which can be used for debugging and
 testing of Erlang programs. For example, breakpoints can be set,
 code can be single stepped and variable values can be inspected
 and modified.


Package: erlang-dialyzer
Architecture: any
Multi-Arch: allowed
Depends: erlang-base (= ${binary:Version}), erlang-syntax-tools (=${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: erlang, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP discrepancy analyzer application
 Dialyzer is a static analysis tool that identifies software
 discrepancies such as type errors, unreachable code, unnecessary
 tests etc. in single Erlang modules or entire (sets of) applications.


Package: erlang-diameter
Architecture: any
Multi-Arch: allowed
Depends: erlang-base (= ${binary:Version}), erlang-runtime-tools (= ${binary:Version}), erlang-ssl (= ${binary:Version}), erlang-syntax-tools (=${binary:Version}), ${misc:Depends}
Suggests: erlang, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP implementation of RFC 6733 protocol
 Interface with which a user creates a service that sends and receives
 messages using the Diameter protocol as defined in RFC 6733.


Package: erlang-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, libjs-jquery-ui, ${misc:Depends}
Suggests: erlang:any
Conflicts: erlang-doc-html, erlang-base:any (<< 1:13.b.4), erlang-base-hipe:any
Replaces: erlang-doc-html
Provides: erlang-doc-html
Description: Erlang/OTP HTML documentation
 Documentation for the Erlang programming language and OTP
 library in HTML format.


Package: erlang-edoc
Architecture: any
Multi-Arch: allowed
Depends: erlang-base (= ${binary:Version}), erlang-syntax-tools (=${binary:Version}), erlang-xmerl (= ${binary:Version}), ${misc:Depends}
Suggests: erlang, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP module for generating documentation
 EDoc is the Erlang program documentation generator. Inspired by the
 Javadoc tool for the Java programming language, EDoc is adapted to
 the conventions of the Erlang world.


Package: erlang-eldap
Architecture: any
Multi-Arch: allowed
Depends: erlang-base (= ${binary:Version}), erlang-asn1 (= ${binary:Version}), erlang-ssl (=${binary:Version}), ${misc:Depends}
Suggests: erlang, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP LDAP library
 Eldap is a module which provides a client API to the Lightweight
 Directory Access Protocol (LDAP).


Package: erlang-et
Architecture: any
Multi-Arch: allowed
Depends: erlang-base (= ${binary:Version}), erlang-runtime-tools (= ${binary:Version}), erlang-wx (= ${binary:Version}), ${misc:Depends}
Suggests: erlang, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP event tracer application
 The Event Tracer (ET) uses the built-in trace mechanism in Erlang
 and provides tools for collecting and examining trace data using GUI.


Package: erlang-eunit
Architecture: any
Multi-Arch: allowed
Depends: erlang-base (= ${binary:Version}), ${misc:Depends}
Suggests: erlang, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP module for unit testing

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildopts.mk

ifneq ($(DEB_BUILD_OPTION_PARALLEL),)
    JOBS = $(DEB_BUILD_OPTION_PARALLEL)
else
    JOBS = 1
endif

ROOT_DIR=$(shell pwd)

export HOME := $(ROOT_DIR)/debian

-include $(ROOT_DIR)/erts/vsn.mk
-include $(ROOT_DIR)/lib/diameter/vsn.mk
-include $(ROOT_DIR)/lib/erl_interface/vsn.mk
-include $(ROOT_DIR)/lib/jinterface/vsn.mk
-include $(ROOT_DIR)/lib/ic/vsn.mk
-include $(ROOT_DIR)/lib/tools/vsn.mk
-include $(ROOT_DIR)/lib/common_test/vsn.mk
-include $(ROOT_DIR)/lib/snmp/vsn.mk
-include $(ROOT_DIR)/lib/observer/vsn.mk
-include $(ROOT_DIR)/lib/edoc/vsn.mk

SOURCE_VERSION=$(shell dpkg-parsechangelog | sed -ne's!^Version: \(.*\)-.*!\1!p')

PCRE_MAJOR=$(shell cat erts/emulator/pcre/pcre.h | grep PCRE_MAJOR | sed -e's/.*\s\([0-9]\+\).*/\1/')
PCRE_MINOR=$(shell cat erts/emulator/pcre/pcre.h | grep PCRE_MINOR | sed -e's/.*\s\([0-9]\+\).*/\1/')
PCRE_VERSION=$(PCRE_MAJOR).$(PCRE_MINOR)
ABI_VERSION=17.0

MAN_DIR = $(ROOT_DIR)/debian/tmp/usr/share/man/man1

ifneq ($(findstring hurd-i386,$(DEB_HOST_ARCH)),)
YEAR2038_OPT=--disable-year2038
else
YEAR2038_OPT=
endif

ifneq ($(findstring hurd,$(DEB_HOST_ARCH)),)
ESOCK_OPT=--disable-esock
else
ESOCK_OPT=--enable-esock
endif

ifneq ($(findstring hurd,$(DEB_HOST_ARCH)),)
KERNEL_POLL_OPT=--disable-kernel-poll
else
KERNEL_POLL_OPT=--enable-kernel-poll
endif

LIBSCTP=$(shell grep-status -s Depends -PX libsctp-dev |sed -e 's!.*\(libsctp[0-9]*\).*!\1!')
LIBSCTPDEP=$(shell grep-status -s Version -PX $(LIBSCTP) | sed -e's!^Version: \(.*\)-[^-]*!$(LIBSCTP) (>= \1)!')

ifeq ($(findstring hurd,$(DEB_HOST_ARCH))$(findstring bsd,$(DEB_HOST_ARCH)),)
SYSTEMD_OPT=--enable-systemd
SCTP_OPT=--enable-sctp
else
SYSTEMD_OPT=
SCTP_OPT=--disable-sctp
endif

ifeq ($(findstring i386,$(DEB_HOST_ARCH)),)
SSE2=
else
SSE2=-msse2
endif

ifeq ($(findstring armel,$(DEB_HOST_ARCH)),)
OPTIMIZATION=-O2
else
OPTIMIZATION=-O1
endif

ifeq ($(findstring debug,$(DEB_BUILD_OPTIONS)),debug)
CFLAGS=-g $(OPTIMIZATION) -fno-strict-aliasing $(SSE2)
GEN_OPT_FLGS=$(OPTIMIZATION) -fno-strict-aliasing $(SSE2)
TYPE=debug
else
CFLAGS=-g $(OPTIMIZATION) -fno-strict-aliasing $(SSE2)
GEN_OPT_FLGS=$(OPTIMIZATION) -fno-strict-aliasing $(SSE2)
TYPE=
endif

JAVA_OPTIONS=-Xlint -source 1.8 -target 1.8

export LC_ALL := C.UTF-8

MANPAGE_DIRS = $(shell find $(ROOT_DIR) -not \( -wholename '*/.pc' -prune \) \
	       			-a \( -name '*_cmd.md' -or -name dialyzer.erl \) -exec dirname {} _cmd.md \; | tr "\n" ":")
MANPAGE_NAMES = $(shell find $(ROOT_DIR) -not \( -wholename '*/.pc' -prune \) \
				-a -name '*_cmd.md' -exec basename {} _cmd.md \;) dialyzer start_embedded
MANPAGES = $(MANPAGE_NAMES:%=$(MAN_DIR)/%.1)

vpath %_cmd.md $(MANPAGE_DIRS)

# manpages builds section 1 manual pages

manpages: manpages-stamp
manpages-stamp: $(MANPAGES)
	dh_testdir
	touch manpages-stamp

$(MAN_DIR):
	install -d $(MAN_DIR)

$(MAN_DIR)/start_embedded.1: $(MAN_DIR)/start.1
	sed -e's/START/START_EMBEDDED/' \
	    -e's/Bstart\([ \\]\)/Bstart_embedded\1/' <$< >$@

$(MAN_DIR)/dialyzer.1: lib/dialyzer/src/dialyzer.erl $(MAN_DIR)
	debian/scripts/fixmanpage $< 1 | ronn | sed -e's/start(1)/start_embedded(1)/' >$@

$(MAN_DIR)/%.1: %_cmd.md $(MAN_DIR)
	debian/scripts/fixmanpage $< 1 | ronn | sed -e's/start(1)/start_embedded(1)/' >$@

# Files generated from templates

SCRIPTS_SRC = $(wildcard debian/erlang-*.in) $(wildcard debian/scripts/*.in)
SCRIPTS = $(SCRIPTS_SRC:%.in=%)

$(SCRIPTS) debian/control: %: %.in debian/rules
	sed -e's/@VERSION@/$(VSN)/g' \
	    -e's/@SOURCE_VERSION@/$(SOURCE_VERSION)/g' \
	    -e's/@ABI_VERSION@/$(ABI_VERSION)/g' \
	    -e's/@PCRE_VERSION@/$(PCRE_VERSION)/g' \
	    -e's/@EI_VSN@/$(EI_VSN)/g' \
	    -e's/@JINTERFACE_VSN@/$(JINTERFACE_VSN)/g' \
	    -e's/@IC_VSN@/$(IC_VSN)/g' \
	    -e's/@COMMON_TEST_VSN@/$(COMMON_TEST_VSN)/g' \
	    -e's/@SNMP_VSN@/$(SNMP_VSN)/g' \
	    -e's/@DIAMETER_VSN@/$(DIAMETER_VSN)/g' \
	    -e's/@OBSERVER_VSN@/$(OBSERVER_VSN)/g' \
	    -e's/@EDOC_VSN@/$(EDOC_VSN)/g' \
	    -e's/@TOOLS_VSN@/$(TOOLS_VSN)/g' <$< >$@

# Building the package

clean:
	dh_testdir
	dh_testroot
	#
	[ ! -f Makefile ] || $(MAKE) -j $(JOBS) clean
	#
	# Remove installed erlang from debian/
	rm -rvf debian/erlang-docs
	#
	# Restore replaced configure, config.guess, and config.sub files
	for i in `find $(ROOT_DIR) -regex '.*config\(ure\|\.guess\|\.sub\)~'` ; do \
	    mv -v $$i $${i%%\~} ; \
	done
	#
	# Remove files, which were generated from templates
	rm -vf $(SCRIPTS)
	#
	# *.install were also generated on-the-fly
	rm -vf debian/*.install
	rm -vf debian/erlang-doc.links
	#
	rm -vf debian/AUTHORS
	#
	# Remove touched stamp files
	rm -vf *-stamp
	#
	dh_clean -Xtest.erl.orig

automake: automake-stamp
automake-stamp: debian/control
	dh_testdir
	#
	# Return error if there are known nonfree docs in upstream tarball
	# Return error if there are prebuilt binaries in upstream tarball
	err=0 ; \
	for fn in `find lib/*/doc -name standard -or -name archive` ; do \
	    err=1 ; \
	    echo Found directory $$fn with non-free docs in upstream. Please remove it. ; \
	done ; \
	if [ -f prebuilt.files ] ; then \
	    err=1 ; \
	    echo Found prebuilt binaries in upstream. Please remove them. ; \
	fi ; \
	if [ $$err = 1 ] ; then \
	    echo ; \
	    echo Use uscan --download to get the upstream tarball. ; \
	    echo ; \
	    false ; \
	fi
	#
	# Preserve configure scripts
	for i in `find $(ROOT_DIR) -not \( -wholename '*/.pc' -prune \) \
				    -a -name 'configure'` ; do \
	    cp -vf $$i $$i~ ; \
	done
	#
	# Replace config.guess and config.sub by installed in /usr/share/misc.
	for i in `find $(ROOT_DIR) -not \( -wholename '*/.pc' -prune \) \
				    -a -name 'config.guess'` ; do \
	    cp -vfb /usr/share/misc/config.guess $$i ; \
	done
	for i in `find $(ROOT_DIR) -not \( -wholename '*/.pc' -prune \) \
				    -a -name 'config.sub'` ; do \
	    cp -vfb /usr/share/misc/config.sub $$i ; \
	done
	#
	# Regenerate configure scripts using autoconf
	./otp_build update_configure --no-commit
	#
	touch automake-stamp

configure: configure-stamp
configure-stamp: automake-stamp
	dh_testdir
	#
	CFLAGS="$(CFLAGS)" \
	./configure --host=$(DEB_HOST_GNU_TYPE) \
		    --build=$(DEB_BUILD_GNU_TYPE) \
		    --prefix=/usr \
		    --libexecdir=/usr/bin \
		    --infodir=/usr/share/info \
		    --mandir=/usr/share/man \
		    $(KERNEL_POLL_OPT) \
		    $(ESOCK_OPT) \
		    $(SYSTEMD_OPT) \
		    $(SCTP_OPT) \
		    $(YEAR2038_OPT) \
		    --enable-dynamic-ssl-lib \
		    --with-ssl-rpath=no \
		    --enable-shared-zlib \
		    --disable-builtin-zlib \
		    --without-ssl-zlib \
		    --disable-silent-rules
	#
	touch configure-stamp

boot: boot-stamp
boot-stamp: configure-stamp
	dh_testdir
	$(MAKE) -j $(JOBS) TYPE=$(TYPE) GEN_OPT_FLGS="$(GEN_OPT_FLGS)" JAVA_OPTIONS="$(JAVA_OPTIONS)"
	touch boot-stamp

install: install-stamp
install-stamp: boot-stamp
	dh_testdir
	#
	$(MAKE) -j $(JOBS) DESTDIR=$(ROOT_DIR)/debian/tmp TYPE=$(TYPE) install
	#
	# Replace ROOTDIR in "erl" and "start" scripts for real rootdir
	# If there's no erl or start then it's better to fail than silently continue
	for dir in debian/tmp/usr/lib/erlang/erts-$(VSN)/bin \
		   debian/tmp/usr/lib/erlang/bin; do \
	    for val in erl start; do \
		sed -i 's!ROOTDIR=.*!ROOTDIR=/usr/lib/erlang!' $${dir}/$${val}; \
	    done; \
	done
	#
	# Correct ERL_ROOT in RELEASES file
	sed 's!%ERL_ROOT%!/usr/lib/erlang!' \
	    debian/tmp/usr/lib/erlang/releases/RELEASES.src \
	    >debian/tmp/usr/lib/erlang/releases/RELEASES
	#
	# Get rid of windows cruft
	find debian/tmp -name *.bat -exec rm -v {} \;
	#
	# Fix permissions
	cp debian/tmp/usr/lib/erlang/erts-$(VSN)/bin/start_erl.src \
	   debian/tmp/usr/lib/erlang/erts-$(VSN)/bin/start_erl
	chmod 755 debian/tmp/usr/lib/erlang/erts-$(VSN)/bin/start_erl
	chmod 755 debian/tmp/usr/lib/erlang/erts-$(VSN)/bin/*.src
	chmod 644 debian/tmp/usr/lib/erlang/bin/start.script

## erlang 27.3.4.6+dfsg

=== debian/changelog ===
erlang (1:27.3.4.6+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.

 -- Sergei Golovan <sgolovan@debian.org>  Thu, 27 Nov 2025 15:27:59 +0300

## erlang 28.0.1+dfsg

=== debian/changelog ===
erlang (1:28.0.1+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Upload to experimental.

 -- Sergei Golovan <sgolovan@debian.org>  Mon, 16 Jun 2025 14:35:35 +0300

erlang (1:28.0+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Upload to experimental.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 21 May 2025 11:22:24 +0300

## erlang 28.0.2+dfsg

=== debian/changelog ===
erlang (1:28.0.2+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Upload to experimental.
  * Fix erlang-base.prerm and erlang-base.postinst scripts code that
    searches for the erlang-dependent services.
  * Reorganize debian/rules to respect "parallel=N" when passed
    in DEB_BUILD_OPTIONS.
  * Drop providing erlang-pcre by erlang-base because it is not used by
    any package and is not necessary anymore.
  * Bump standards version to 4.7.2.

 -- Sergei Golovan <sgolovan@debian.org>  Sun, 20 Jul 2025 13:42:20 +0300
